<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Formatting macro for constructing `Ident`s."><meta name="keywords" content="rust, rustlang, rust-lang, format_ident"><title>format_ident in quote - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../normalize.css"><link rel="stylesheet" type="text/css" href="../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../dark.css" disabled><link rel="stylesheet" type="text/css" href="../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../storage.js"></script><script defer src="sidebar-items.js"></script><script defer src="../main.js"></script><noscript><link rel="stylesheet" href="../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../favicon.svg"></head><body class="rustdoc macro"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../quote/index.html"><div class="logo-container"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../quote/index.html"><div class="logo-container"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></div>
        </a><div class="sidebar-elems"><h2 class="location"><a href="index.html">In quote</a></h2></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../quote/index.html"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Macro <a href="index.html">quote</a>::<wbr><a class="macro" href="#">format_ident</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../src/quote/format.rs.html#111-125">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><div class="docblock item-decl"><div class="example-wrap"><pre class="rust macro"><code><span class="macro">macro_rules!</span> <span class="ident">format_ident</span> {
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">fmt</span>:<span class="ident">expr</span>) =&gt; { ... };
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">fmt</span>:<span class="ident">expr</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) =&gt; { ... };
}</code></pre></div>
</div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>Formatting macro for constructing <code>Ident</code>s.</p>
<br>
<h2 id="syntax"><a href="#syntax">Syntax</a></h2>
<p>Syntax is copied from the <a href="https://doc.rust-lang.org/nightly/alloc/macro.format.html" title="format!"><code>format!</code></a> macro, supporting both positional and
named arguments.</p>
<p>Only a limited set of formatting traits are supported. The current mapping
of format types to traits is:</p>
<ul>
<li><code>{}</code> ⇒ <a href="trait.IdentFragment.html"><code>IdentFragment</code></a></li>
<li><code>{:o}</code> ⇒ <a href="https://doc.rust-lang.org/nightly/core/fmt/trait.Octal.html"><code>Octal</code></a></li>
<li><code>{:x}</code> ⇒ <a href="https://doc.rust-lang.org/nightly/core/fmt/trait.LowerHex.html"><code>LowerHex</code></a></li>
<li><code>{:X}</code> ⇒ <a href="https://doc.rust-lang.org/nightly/core/fmt/trait.UpperHex.html"><code>UpperHex</code></a></li>
<li><code>{:b}</code> ⇒ <a href="https://doc.rust-lang.org/nightly/core/fmt/trait.Binary.html"><code>Binary</code></a></li>
</ul>
<p>See <a href="https://doc.rust-lang.org/nightly/alloc/fmt/index.html" title="std::fmt"><code>std::fmt</code></a> for more information.</p>
<br>
<h2 id="identfragment"><a href="#identfragment">IdentFragment</a></h2>
<p>Unlike <code>format!</code>, this macro uses the <a href="trait.IdentFragment.html"><code>IdentFragment</code></a> formatting trait by
default. This trait is like <code>Display</code>, with a few differences:</p>
<ul>
<li><code>IdentFragment</code> is only implemented for a limited set of types, such as
unsigned integers and strings.</li>
<li><a href="../proc_macro2/struct.Ident.html"><code>Ident</code></a> arguments will have their <code>r#</code> prefixes stripped, if present.</li>
</ul>
<br>
<h2 id="hygiene"><a href="#hygiene">Hygiene</a></h2>
<p>The <a href="../proc_macro2/struct.Span.html"><code>Span</code></a> of the first <code>Ident</code> argument is used as the span of the final
identifier, falling back to <a href="../proc_macro2/struct.Span.html#method.call_site"><code>Span::call_site</code></a> when no identifiers are
provided.</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="comment">// If `ident` is an Ident, the span of `my_ident` will be inherited from it.</span>
<span class="kw">let</span> <span class="ident">my_ident</span> <span class="op">=</span> <span class="macro">format_ident!</span>(<span class="string">&quot;My{}{}&quot;</span>, <span class="ident">ident</span>, <span class="string">&quot;IsCool&quot;</span>);
<span class="macro">assert_eq!</span>(<span class="ident">my_ident</span>, <span class="string">&quot;MyIdentIsCool&quot;</span>);</code></pre></div>
<p>Alternatively, the span can be overridden by passing the <code>span</code> named
argument.</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">let</span> <span class="ident">my_span</span> <span class="op">=</span> <span class="comment">/* ... */</span>;
<span class="macro">format_ident!</span>(<span class="string">&quot;MyIdent&quot;</span>, <span class="ident">span</span> <span class="op">=</span> <span class="ident">my_span</span>);</code></pre></div>
<p><br></p>
<h2 id="panics"><a href="#panics">Panics</a></h2>
<p>This method will panic if the resulting formatted string is not a valid
identifier.</p>
<br>
<h2 id="examples"><a href="#examples">Examples</a></h2>
<p>Composing raw and non-raw identifiers:</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">let</span> <span class="ident">my_ident</span> <span class="op">=</span> <span class="macro">format_ident!</span>(<span class="string">&quot;My{}&quot;</span>, <span class="string">&quot;Ident&quot;</span>);
<span class="macro">assert_eq!</span>(<span class="ident">my_ident</span>, <span class="string">&quot;MyIdent&quot;</span>);

<span class="kw">let</span> <span class="ident">raw</span> <span class="op">=</span> <span class="macro">format_ident!</span>(<span class="string">&quot;r#Raw&quot;</span>);
<span class="macro">assert_eq!</span>(<span class="ident">raw</span>, <span class="string">&quot;r#Raw&quot;</span>);

<span class="kw">let</span> <span class="ident">my_ident_raw</span> <span class="op">=</span> <span class="macro">format_ident!</span>(<span class="string">&quot;{}Is{}&quot;</span>, <span class="ident">my_ident</span>, <span class="ident">raw</span>);
<span class="macro">assert_eq!</span>(<span class="ident">my_ident_raw</span>, <span class="string">&quot;MyIdentIsRaw&quot;</span>);</code></pre></div>
<p>Integer formatting options:</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">let</span> <span class="ident">num</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="number">10</span>;

<span class="kw">let</span> <span class="ident">decimal</span> <span class="op">=</span> <span class="macro">format_ident!</span>(<span class="string">&quot;Id_{}&quot;</span>, <span class="ident">num</span>);
<span class="macro">assert_eq!</span>(<span class="ident">decimal</span>, <span class="string">&quot;Id_10&quot;</span>);

<span class="kw">let</span> <span class="ident">octal</span> <span class="op">=</span> <span class="macro">format_ident!</span>(<span class="string">&quot;Id_{:o}&quot;</span>, <span class="ident">num</span>);
<span class="macro">assert_eq!</span>(<span class="ident">octal</span>, <span class="string">&quot;Id_12&quot;</span>);

<span class="kw">let</span> <span class="ident">binary</span> <span class="op">=</span> <span class="macro">format_ident!</span>(<span class="string">&quot;Id_{:b}&quot;</span>, <span class="ident">num</span>);
<span class="macro">assert_eq!</span>(<span class="ident">binary</span>, <span class="string">&quot;Id_1010&quot;</span>);

<span class="kw">let</span> <span class="ident">lower_hex</span> <span class="op">=</span> <span class="macro">format_ident!</span>(<span class="string">&quot;Id_{:x}&quot;</span>, <span class="ident">num</span>);
<span class="macro">assert_eq!</span>(<span class="ident">lower_hex</span>, <span class="string">&quot;Id_a&quot;</span>);

<span class="kw">let</span> <span class="ident">upper_hex</span> <span class="op">=</span> <span class="macro">format_ident!</span>(<span class="string">&quot;Id_{:X}&quot;</span>, <span class="ident">num</span>);
<span class="macro">assert_eq!</span>(<span class="ident">upper_hex</span>, <span class="string">&quot;Id_A&quot;</span>);</code></pre></div>
</div></details></section></div></main><div id="rustdoc-vars" data-root-path="../" data-current-crate="quote" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>